function addYourLocationButton (mapObject) 
{
    var findmeDiv = document.createElement('div');

    var findmeButton = document.createElement('div');
    findmeButton.style.backgroundColor = '#fff';
    findmeButton.style.border = 'none';
    findmeButton.style.outline = 'none';
    findmeButton.style.width = '40px';
    findmeButton.style.height = '40px';
    findmeButton.style.borderRadius = '2px';
    findmeButton.style.boxShadow = '0 1px 4px rgba(0,0,0,0.3)';
    findmeButton.style.cursor = 'pointer';
    findmeButton.style.marginRight = '10px';
    findmeButton.style.padding = '1px';
    //findmeButton.title = 'Your Location';
    findmeDiv.appendChild(findmeButton);

    var findmeButtonIcon = document.createElement('div');
    findmeButtonIcon.style.margin = '11px';
    findmeButtonIcon.style.width = '18px';
    findmeButtonIcon.style.height = '18px';
    findmeButtonIcon.style.backgroundImage = 'url(https://maps.gstatic.com/tactile/mylocation/mylocation-sprite-2x.png)';
    findmeButtonIcon.style.backgroundSize = '180px 18px';
    findmeButtonIcon.style.backgroundPosition = '0 0';
    findmeButtonIcon.style.backgroundRepeat = 'no-repeat';
    findmeButton.appendChild(findmeButtonIcon);

    google.maps.event.addListener(mapObject, 'center_changed', function () {
        findmeButtonIcon.style['background-position'] = '0 0';
    });

    findmeButton.addEventListener('click', function () {
        var imgX = '0',
            animationInterval = setInterval(function () {
                imgX = imgX === '-18' ? '0' : '-18';
                findmeButtonIcon.style['background-position'] = imgX+'px 0';
            }, 500);

        if(navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
				codeLatLng(position.coords.latitude, position.coords.longitude);
                var latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
                mapObject.setCenter(latlng);

				var marker = new google.maps.Marker({
					position: latlng,
					map: mapObject,
					icon: CMLOC_Map_Settings.geolocationFindmeIcon,
					title: position.coords.latitude + "," + position.coords.longitude
					//title: "<div style = 'height:60px;width:200px'><b>Your location:</b><br />Latitude: " + position.coords.latitude + "<br />Longitude: " + position.coords.longitude
				});
				/*
				google.maps.event.addListener(marker, "click", function (e) {
					var infoWindow = new google.maps.InfoWindow();
					infoWindow.setContent(marker.title);
					infoWindow.open(mapObject, marker);
				});
				*/

                clearInterval(animationInterval);
                findmeButtonIcon.style['background-position'] = '-144px 0';
            });
        } else {
            clearInterval(animationInterval);
            findmeButtonIcon.style['background-position'] = '0 0';
        }
    });

    findmeDiv.index = 1;
    mapObject.controls[google.maps.ControlPosition.RIGHT_BOTTOM].push(findmeDiv);
}

function codeLatLng(lat, lng) {
	var geocoder;
	geocoder = new google.maps.Geocoder();
    var latlng = new google.maps.LatLng(lat, lng);
    geocoder.geocode({'latLng': latlng}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
      //console.log(results)
        if (results[1]) {
         //formatted address
        // alert(results[0].formatted_address)
        //find country name
             for (var i=0; i<results[0].address_components.length; i++) {
            for (var b=0;b<results[0].address_components[i].types.length;b++) {

            //there are different types that might hold a city admin_area_lvl_1 usually does in come cases looking for sublocality type will be more appropriate
                if (results[0].address_components[i].types[b] == "postal_code") {
                    //this is the object you are looking for
                    postal_code= results[0].address_components[i];
                    break;
                }
            }
        }
        //postal_code data
		if(jQuery("form.cmloc-location-filter-form").length > 0) {
			var zipcode = postal_code.long_name;
			if(zipcode != '') {
				jQuery("form.cmloc-location-filter-form").find(".cmloc-input-search").val(zipcode);
				jQuery("form.cmloc-location-filter-form").submit();
			}
		}


        } else {
          //alert("No results found");
        }
      } else {
        //alert("Geocoder failed due to: " + status);
      }
    });
  }

jQuery(function($) {

	$('.cmloc-embed-btn a').click(function(ev) {
		ev.preventDefault();
		var wrapper = $(this).parents('.cmloc-toolbar').parent();
		var overlay = CMLOC.Utils.overlay(wrapper.find('.cmloc-route-embed'));
		overlay.find('.cmloc-route-embed').show();
		overlay.find('.cmloc-route-embed textarea').click(function() {
			this.select();
		});
		$(".cmloc-route-embed-copy-btn", overlay).click(function(e) {
			e.preventDefault();
			var wrapper = $(this).parents('.cmloc-route-embed');
		    wrapper.find("textarea").select();
		    document.execCommand('copy');
		});
	});

	
	$('body').on('click', '.cmloc_business_hour_index_link', function() {
		if($(this).parents('.cmloc-business-hour-index').find('.cmloc-business-hour-index-inner').css('display') == 'none') {
			$(this).parents('.cmloc-business-hour-index').find('.cmloc-business-hour-index-inner').css('display', 'block');
			$(this).find('span').html('-');
		} else {
			$(this).parents('.cmloc-business-hour-index').find('.cmloc-business-hour-index-inner').css('display', 'none');
			$(this).find('span').html('+');
		}
	});
	
	$('body').on('click', '.cmlbh_checkbox_hidden input[type="checkbox"]', function() {
		if($(this).prop('checked') == false) {
			$(this).parents('label').find('input[type="hidden"]').val('0');
		} else {
			$(this).parents('label').find('input[type="hidden"]').val('1');
		}
	});

});