<?php

namespace com\cminds\maplocations\model;

class ExpertCategory extends TaxonomyTerm {

	const TAXONOMY = 'cm-expert-category';
	const CATEGORY_PERMALINK_PART = 'cm-expert-category';
	const OPTION_LOCATIONS_DEFAULT_ICONS = 'cmed_category_icons';
	
	
	static function getUrlPart() {
		return self::CATEGORY_PERMALINK_PART;
	}
	
    
    /**
	 * Get instance
	 * 
	 * @param object|int $term Term object or ID
	 * @return com\cminds\maplocations\model\ExpertCategory
	 */
	static function getInstance($term) {
		return parent::getInstance($term);
	}
	
	
	function getIcon() {
		$options = get_option(self::OPTION_LOCATIONS_DEFAULT_ICONS, array());
		$id = $this->getId();
		if (isset($options[$id])) {
			return $options[$id];
		}
	}
	
	

	function setIcon($icon) {
		$options = get_option(self::OPTION_LOCATIONS_DEFAULT_ICONS, array());
		$id = $this->getId();
		$options[$id] = $icon;
		update_option(self::OPTION_LOCATIONS_DEFAULT_ICONS, $options);
		return $this;
	}
	
	
    
}
