<?php
namespace com\cminds\maplocations\shortcode;

use com\cminds\maplocations\controller\ExpertController;
use com\cminds\maplocations\model\ExpertCategory;
use com\cminds\maplocations\model\Expert;
use com\cminds\maplocations\helper\RouteView;
use com\cminds\maplocations\model\MapRoute;
use com\cminds\maplocations\controller\FrontendController;
use com\cminds\maplocations\model\Settings;
use com\cminds\maplocations\controller\RouteController;
use com\cminds\maplocations\model\Route;

class ExpertShortcode extends Shortcode {
	
	const SHORTCODE_NAME = 'cmloc-expert';
	
	static function shortcode($atts) {
		
		$atts = shortcode_atts(array(
			'category' => null,
			'categoryfilter' => 1,
			'searchbar' => 1,
			's' => '',
			'theme' => false,
			'ids' => '',
			'mapwidth' => '',
			'mapheight' => '',
			'width' => '',
		), $atts);

		$mapStyle = RouteController::getStyle($atts['theme']);

		if ($categoryObj = ExpertCategory::getInstance($atts['category'])) {
			$currentCategoryId = $categoryObj->getId();
			$atts['category'] = $categoryObj->getSlug();
		} else {
			$atts['category'] = $currentCategoryId = '';
		}
		
		$query = array(
			'post_type' => Expert::POST_TYPE,
			'post_status' => 'publish',
			ExpertCategory::TAXONOMY => (!empty($atts['category']) ? $atts['category'] : null),
			'posts_per_page' => -1,
			'paged' => 1,
			's' => $atts['s'],
			'post__in' => array_filter(is_array($atts['ids']) ? $atts['ids'] : explode(',', $atts['ids'])),
			'ignore_sticky' => true,
		);
		
		$routes = Expert::getIndexMapJSLocations($query);
		
		//if ($routes) {
			
			FrontendController::enqueueStyle();
			wp_enqueue_script('cmloc-index-map');
			wp_enqueue_script('cmloc-expert-map-shortcode');
			
			RouteController::loadSinglePageScripts();
			$displayParams = Settings::getOption(Settings::OPTION_INDEX_ROUTE_PARAMS);
			
			$content = RouteController::loadFrontendView('index-map', compact('mapStyle','routes', 'atts'));
			
			if ($atts['categoryfilter']) {
				$categories = ExpertCategory::getTreeArray();
				$content = ExpertController::loadFrontendView('filter', compact('categories', 'atts', 'currentCategoryId')) . $content;
			}
			
			$extra = RouteView::getDisplayParams($displayParams);
			if (!empty($atts['width'])) {
				$extra .= ' style="max-width:'. $atts['width'] .'px;"';
			}
			
			return sprintf('<div class="cmloc-map-shortcode cmloc-locations-archive cmloc-expert-shortcode"%s>%s</div>',
				$extra,
				$content
			);
		//}
		
	}

}