<?php 
use com\cminds\maplocations\helper\GoogleMapsIcons;
use com\cminds\maplocations\model\Category;

if (!empty($term)) $template = <<<HTML
	<tr class="form-field">
		<th scope="row"><label for="cmloc_category_icon">%s</label></th>
		<td>%s</td>
	</tr>
HTML;
else $template = <<<HTML
	<div class="form-field">
		<label for="cmloc_category_icon">%s</label>
		%s
	</div>
HTML;

$options = '';
foreach ($icons as $icon) {
	$options .= sprintf('<img src="%s">', esc_attr($icon));
}

if (!empty($currentIcon)) {
	$current = '<img src="'. esc_attr($currentIcon) .'" class="cmloc_category_icon_image" style="max-width:64px;max-height:64px;" />
		<input type="hidden" name="cmloc_category_icon" value="'. esc_attr($currentIcon) .'" />';
} else {
	$current = '<img class="cmloc_category_icon_image" style="max-width:64px;max-height:64px;" /><input type="hidden" name="cmloc_category_icon" value="" />';
}

$content = <<<HTML
	<div class="cmloc_category_icon">
		<p id="category-image-wrapper">%s</p>
		<p>
			<input type="button" value="Choose icon" class="cmloc_category_icon_choose" style="cursor:pointer;" />
			<input type="button" value="Upload icon" class="cmloc_category_icon_upload" style="cursor:pointer;" />
			<input type="button" value="Remove icon" class="cmloc_category_icon_remove" style="cursor:pointer;" />
		</p>
		<div class="cmloc_category_icon_list" style="display:none">%s</div>
		<input type="hidden" name="%s" value="%s" />
	</div>
HTML;

$content = sprintf($content, $current, $options, $nonceField, $nonce);

printf($template, 'Default marker icon for new locations', $content);

if (!empty($term)) $template2 = <<<HTML
	<tr class="form-field">
		<th scope="row"><label for="cmloc_category_icon">%s</label></th>
		<td>%s</td>
	</tr>
HTML;
else $template2 = <<<HTML
	<div class="form-field">
		<label for="cmloc_category_icon">%s</label>
		%s
	</div>
HTML;

$locationcontent = '<div id="cmloc_category-file-wrapper">';
$files_list = array();
$id = 0;
if ($term AND $location = Category::getInstance($term)) {
	$id = $term->term_id;
	$files_list = $location->getLocationFileList();
}
if ( is_array( $files_list ) ) {
	foreach ( $files_list as $file_list ) {
		$locationcontent .= '<div class="cmloc_added_files_placeholder"><b>' . $file_list['title'] . '</b><a href="' . $file_list['url'] . '" target="_blank">' . basename($file_list['url']) .'</a><input type="hidden" class="cmloc_remove_file_id"  value="' . $file_list['id'] . '" /><input type="button" class="cmloc_remove_file_button" title="Remove" value="X" /></div>'; 
	}
}
$locationcontent .= '</div>';
$locationcontent .= '<div id="cmloc_category_file_placeholder">';
$locationcontent .= '</div>';
$locationcontent .= '<p>';
$locationcontent .= '<input type="hidden" id ="cmloc_location_remove_files" name="cmloc_location_remove_files"  value="">';
$locationcontent .= '<input type="button" class="button button-secondary ct_tax_media_file_button" id="cmloc_media_file_button" name="ct_tax_media_file_button" value="Select Files" />';
$locationcontent .= '</p>';

$locationcontentscript = <<<HTML
<style>
.cmloc_added_files_placeholder { clear:both; float:left; width:100%; }
.cmloc_added_files_placeholder .cmloc_title_text_input { width:150px !important; float:left; }
.cmloc_added_files_placeholder .cmloc_upload_file_name { float: left; margin: 5px 0 0 5px; }
.cmloc_added_files_placeholder .cmloc_remove_file_button { float:right; cursor:pointer; }
#cmloc_category_file_placeholder { margin-bottom:10px; }
.cmloc_added_files_placeholder { margin-bottom:5px; }
.cmloc_added_files_placeholder b { margin-right:10px; }
</style>
<script>
jQuery(document).ready( function( $ ) {

	var myfile_upload;

	$('#cmloc_media_file_button').click(function(e) {
		e.preventDefault();

		if( myfile_upload ) {
			myfile_upload.open();
			return;
		}

		myfile_upload = wp.media.frames.file_frame = wp.media({
			title: "Select the file",
			button: { text: "select" },
			multiple: true

		});

		myfile_upload.on( 'select', function(){
			var attachments = myfile_upload.state().get('selection').map( 
			function( attachments ) {
				attachments.toJSON();
				return attachments;
			});

			for (i = 0; i < attachments.length; ++i) {
				$('#cmloc_category_file_placeholder').after(
					'<div class="cmloc_added_files_placeholder">' +
					'<input type="text" class="cmloc_title_text_input" name="cmloc_location_add_files_title[' + attachments[i].id + ']" value="" />' + 
					'<input type="hidden" name="cmloc_location_add_files[]"  value="' + attachments[i].id + '" />' +
					' <input type="button" title="Remove" class="cmloc_remove_file_button" value="X" onClick="this.parentNode.parentNode.removeChild(this.parentNode);" /><span class="cmloc_upload_file_name">' +
					attachments[i].attributes.filename  +'</span> </div>'
				);
			}
		});

	myfile_upload.open();

	});

	var holder = $('.cmloc_added_files_placeholder');
	var removeFileList = $('#cmloc_location_remove_files');

	if (holder.length) {
		holder.each(function () {
			var thisHolder = $(this),
				deleteButton = thisHolder.find('.cmloc_remove_file_button'),
				removeFileID = thisHolder.find('.cmloc_remove_file_id');

				deleteButton.on('click', function (e) {
					e.preventDefault();
					
					removeFileListVal = removeFileList.val();
					removeFileListSeparator = ( removeFileListVal != '' ) ? ',' : '';
					removeFileListVal = removeFileListVal + removeFileListSeparator + removeFileID.val();
					removeFileList.val(removeFileListVal);

					thisHolder.remove();
				})
		})
	}
});
</script>
HTML;

printf($template2, 'Files', $locationcontent.$locationcontentscript);