<?php
use com\cminds\maplocations\App;
?>
<?php if (App::isPro()): ?>
    <p><strong>Notice: shortcodes are case-sensitive</strong></p>
	<?php echo apply_filters('cmml_shortcodes_content_before', ''); ?>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cmloc-snippet]</h4>
            <span>Shows the location's snippet.</span>
        </header>
        <div class="cmmrm-shortcode-desc-inner">
            <h5>Filtering parameters:</h5>
            <ul>
                <li><strong>id</strong> - Location's ID</li>
            </ul>
            <h5>View parameters:</h5>
            <ul>
                <li><strong>featured</strong> - one of: image map</li>
            </ul>
            <h5>Example</h5>
            <p><kbd>[cmloc-snippet id=1 featured="map"] </kbd></p>
        </div>

    </article>
<article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cmloc-location-map]</h4>
            <span>Shows the location map.</span>
        </header>
        <div class="cmmrm-shortcode-desc-inner">
            <h5>Filtering parameters:</h5>
            <ul>
                <li><strong>id</strong> - Location's ID</li>
            </ul>
            <h5>View parameters:</h5>
            <ul>
                <li><strong>theme</strong> - one of: silver retro dark night aubergine</li>
                <li><strong>mapheight</strong> - pixels height </li>
                <li><strong>mapwidth</strong> - pixels width </li>
                <li><strong>width</strong> - pixels width </li>
                <li><strong>showtitle</strong> - show title </li>
                <li><strong>showdate</strong> - show date 1 to show or 0 to hide</li>
            </ul>
            <h5>Example</h5>
            <p><kbd>[cmloc-location-map theme='silver' id=1 mapwidth=200
                    mapheight=200 width=600 showtitle=1 showdate=1]</kbd></p>
        </div>
    </article>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cmloc-locations-map]</h4>
            <span>Shows the location's maps.</span>
        </header>
        <div class="cmmrm-shortcode-desc-inner">
            <h5>Filtering parameters:</h5>
            <ul>
                <li><strong>showonlybyparams</strong> - show only by params</li>
                <li><strong>limit</strong> - limit items insert number like 5</li>
                <li><strong>page</strong> - page insert number like 1</li>
                <li><strong>category</strong> - id or slug</li>
            </ul>
            <h5>View parameters:</h5>
            <ul>
                <li><strong>theme</strong> - one of: silver retro dark night aubergine</li>
                <li><strong>list</strong> - one of: none left right bottom compact </li>
                <li><strong>mapwidth</strong> - pixels width </li>
                <li><strong>width</strong> - pixels width </li>
                <li><strong>menu</strong> - show menu 0 or 1 </li>
                <li><strong>tooltip</strong> - show tooltip 1 to show or 0 to hide</li>
            </ul>
            <h5>Example</h5>
            <p><kbd>[cmloc-locations-map
                    showonlybyparams=0
                    theme='silver'
                    list="left" limit=5 page=1
                    category="56"
                    mapwidth=600 mapheight=300 width=600 menu=0 tooltip=0]</kbd></p>
        </div>
    </article>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cmmrm-cmloc-common-map]</h4>
            <span> displays common map with locations and routes from the CM Map Routes Manager plugin.</span>
        </header>
        <div class="cmmrm-shortcode-desc-inner">
            <h5>Filtering parameters:</h5>
            <ul>
                <li><strong>showonlybyparams</strong> - show only by params</li>
                <li><strong>categoryfilter</strong> - show only by params</li>
                <li><strong>categoryfilterautoselect</strong> - show only by params</li>
                <li><strong>showonlybyparams</strong> - show only by params</li>

            </ul>
            <h5>View parameters:</h5>
            <ul>
                <li><strong>theme</strong> - one of: silver retro dark night aubergine</li>
                <li><strong>path</strong> - one of:  0 - 1</li>
                <li><strong>mapheight</strong> - pixels height </li>
                <li><strong>mapwidth</strong> - pixels width </li>
                <li><strong>width</strong> - pixels width </li>
            </ul>
            <h5>Example</h5>
            <p><kbd>[cmmrm-cmloc-common-map theme='silver' path=0 categoryfilter=0 categoryfilterautoselect='' showonlybyparams=0 mapwidth=pixels mapheight=pixels width=pixels menu=0]</kbd></p>
        </div>
    </article>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cm-location-search ]</h4>
            <span> display the locations search.</span>
        </header>

    </article>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[my-locations-table]</h4>
            <span>display the user's locations table.</span>
        </header>

    </article>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cmloc-business]</h4>
            <span>displays map with the CM Business Directory records.</span>
        </header>
        <div class="cmmrm-shortcode-desc-inner">
            <h5>Filtering parameters:</h5>
            <ul>
                <li><strong>category</strong> - id or slug</li>


            </ul>
            <h5>View parameters:</h5>
            <ul>
                <li><strong>theme</strong> - one of: silver retro dark night aubergine</li>
                <li><strong>categoryfilter</strong> 0 or 1</li>
                <li><strong>searchbar</strong> 0 or 1</li>
                <li><strong>mapheight</strong> - pixels height </li>
                <li><strong>mapwidth</strong> - pixels width </li>
                <li><strong>width</strong> - pixels width </li>
            </ul>
            <h5>Example</h5>
            <p><kbd>[cmloc-business category="56" categoryfilter=0 searchbar=0 mapwidth=600 mapheight=500 width=600 theme='silver' ] </kbd></p>
        </div>
    </article>
    <article class="cmmrm-shortcode-desc">
        <header>
            <h4>[cmloc-expert]</h4>
            <span> displays map with the CM Expert Directory records.</span>
        </header>
        <div class="cmmrm-shortcode-desc-inner">
            <h5>Filtering parameters:</h5>
            <ul>
                <li><strong>category</strong> - id or slug</li>


            </ul>
            <h5>View parameters:</h5>
            <ul>
                <li><strong>theme</strong> - one of: silver retro dark night aubergine</li>
                <li><strong>categoryfilter</strong> 0 or 1</li>
                <li><strong>searchbar</strong> 0 or 1</li>
                <li><strong>mapheight</strong> - pixels height </li>
                <li><strong>mapwidth</strong> - pixels width </li>
                <li><strong>width</strong> - pixels width </li>
            </ul>
            <h5>Example</h5>
            <p><kbd>[cmloc-expert category="56" categoryfilter=0 searchbar=0 mapwidth=600 mapheight=600 width=600 theme='silver']</kbd></p>
        </div>
    </article>

	<?php echo apply_filters('cmml_shortcodes_content_after', ''); ?>
<?php endif; ?>