<?php
$displayCategories = function($parentId) use ($categories, &$displayCategories, $autoselect_categories) {
	if (!empty($categories[$parentId]) AND is_array($categories[$parentId])) {
		$autoselect_categories_array = explode(',',$autoselect_categories);
		foreach ($categories[$parentId] as $category) {
			$locations = get_posts(array(
				'post_type' => 'cmloc_object',
				'post_status' => 'publish',
				'posts_per_page' => -1,
				'tax_query' => array(
					array(
					  'taxonomy' => 'cmloc_category',
					  'field' => 'id',
					  'terms' => $category->getId(),
					  'include_children' => false
					)
				  )
			));
			$location_ids = '';
			foreach ($locations as $location)
			{
				$location_ids .= '|'.$location->ID;
			}
			$location_ids = substr($location_ids, 1);
			echo '<li cat_type="cmmlm">';
			
			$checked = '';
			if(in_array($category->getId(), $autoselect_categories_array))
			{
				$checked = 'checked="checked"'; 
			}

			printf('<label><input type="checkbox" value="%s" location_ids="%s" %s /> %s</label>', esc_attr($category->getName()), $location_ids, $checked, esc_html($category->getName()));
			if (!empty($categories[$category->getId()])) {
				echo '<ul>';
				$displayCategories($category->getId());
				echo '</ul>';
			}
			echo '</li>';
		}
	}
};
$displayRoutesCategories = function($parentId) use ($cmmrm_categories, &$displayRoutesCategories, $autoselect_categories) {
	global $wpdb;
	if (!empty($cmmrm_categories[$parentId]) AND is_array($cmmrm_categories[$parentId])) {
		$autoselect_categories_array = explode(',',$autoselect_categories);
		foreach ($cmmrm_categories[$parentId] as $category) {
			$locations = get_posts(array(
				'post_type' => 'cmmrm_route',
				'post_status' => 'publish',
				'posts_per_page' => -1,
				'tax_query' => array(
					array(
					  'taxonomy' => 'cmmrm_category',
					  'field' => 'id',
					  'terms' => $category->getId(),
					  'include_children' => false
					)
				  )
			));
			$location_ids = '';
			foreach ($locations as $location)
			{
				$location_ids .= '|'.$location->ID;
			}
			$location_ids = substr($location_ids, 1);
			echo '<li cat_type="cmmrm">';

			$checked = '';
			if(in_array($category->getId(), $autoselect_categories_array))
			{
				$checked = 'checked="checked"'; 
			}

			printf('<label><input type="checkbox" value="%s" location_ids="%s" %s /> %s</label>', esc_attr($category->getName()), $location_ids, $checked, esc_html($category->getName()));
			if (!empty($cmmrm_categories[$category->getId()])) {
				echo '<ul>';
				$displayRoutesCategories($category->getId());
				echo '</ul>';
			}
			echo '</li>';
		}
	}
};
?>
<div class="cmloc-map-category-filter">
	<ul>
		<?php $displayCategories(0); ?>
		<?php $displayRoutesCategories(0); ?>
	</ul>
</div>