<?php
use com\cminds\maplocations\model\Labels;
use com\cminds\maplocations\model\Settings;
?>
<div class="cmloc-location-index-filter cmloc-filter">
	<form action="<?php echo esc_attr($atts['searchformurl']); ?>" class="cmloc-location-filter-form">
		<?php do_action('cmloc_map_filter_before', $atts); ?>
		<label class="cmloc-field-search">
			<?php
			if(Settings::getOption(Settings::OPTION_INDEX_SEARCH_MODE) == 'nearest') {
				?>
				<input type="text" name="zipcode" placeholder="<?php echo Labels::getLocalized('search_placeholder'); ?>" class="cmloc-input-search" value="<?php echo (isset($_GET['zipcode']))?$_GET['zipcode']:''; ?>" />
				<?php
			} else {
				?>
				<input type="text" name="s" value="<?php echo esc_attr($atts['searchstring']); ?>" placeholder="<?php echo Labels::getLocalized('search_placeholder'); ?>" class="cmloc-input-search" />
				<?php
			}
			?>
			<button type="submit" class="cmloc-submit-btn" title="<?php echo esc_attr(Labels::getLocalized('search_btn')); ?>"><span class="dashicons dashicons-search"></span></button>
		</label>
		<?php
		if(Settings::getOption(Settings::OPTION_INDEX_ZIP_RADIUS_FILTER_POSITION)) {
			do_action('cmloc_map_filter_after_section_one', $atts);
			do_action('cmloc_map_filter_after_section_two', $atts);
		} else {
			do_action('cmloc_map_filter_after_section_two', $atts);
			do_action('cmloc_map_filter_after_section_one', $atts);
		}
		?>
		<?php do_action('cmloc_map_filter_after', $atts); ?>
	</form>
</div>
<?php
if(Settings::getOption(Settings::OPTION_INDEX_ZIP_RADIUS_FILTER_POSITION)) {
?>
<style>.cmloc-zip-filter { float:left; }</style>
<?php
}
?>