<?php
use com\cminds\maplocations\model\Route;
use com\cminds\maplocations\model\Labels;
use com\cminds\maplocations\model\Settings;
use com\cminds\maplocations\controller\RouteController;
use com\cminds\maplocations\controller\DashboardController;
use com\cminds\maplocations\controller\FrontendController;

$atts = $atts ?? '';
$printScript = function() use ($routes, $atts ) {
	?><script type="text/javascript">
	var cmloc_location_index_map_canvas_data = <?php echo json_encode($routes); ?>;
	jQuery(function($) {
		if (typeof window.cmlocMaps == 'undefined') window.cmlocMaps = [];
		if (document.getElementById('cmloc-location-index-map-canvas')) {
			window.cmlocMaps.push(new CMLOC_Index_Map('cmloc-location-index-map-canvas', <?php echo json_encode($routes); ?>, <?php echo (isset($atts["tooltip"]))?$atts["tooltip"]:1; ?>));
		}
	});
	</script><?php
};
$index_map_enable = Settings::getOption(Settings::OPTION_INDEX_MAP_ENABLE);
$index_menu_enable = Settings::getOption(Settings::OPTION_INDEX_MENU_ENABLE);
if((isset($atts['menu']) && $atts['menu'] == '1') || (!isset($atts['menu']) && $index_menu_enable == '1')) {
?>
<div class="cmloc-index-menu">
	<ul>
		<li><a href="<?php echo esc_attr(FrontendController::getUrl()); ?>"><?php echo Labels::getLocalized('menu_all_locations'); ?></a></li>
		<?php if (Route::canCreate()): ?>
			<li><a href="<?php echo esc_attr(RouteController::getDashboardUrl('index')); ?>"><?php echo Labels::getLocalized('menu_my_locations'); ?></a></li>
			<li><a href="<?php echo esc_attr(RouteController::getDashboardUrl('add')); ?>"><?php echo Labels::getLocalized('menu_add_location'); ?></a></li>
			<?php if (!empty($route) AND $route->canEdit()): ?>
				<?php if (FrontendController::isDashboard() AND 'publish' == $route->getStatus()): ?>
					<li><a href="<?php echo esc_attr($route->getPermalink()); ?>"><?php echo Labels::getLocalized('menu_view_location'); ?></a></li>
				<?php else: ?>
					<li><a href="<?php echo esc_attr($route->getUserEditUrl()); ?>"><?php echo Labels::getLocalized('menu_edit_location'); ?></a></li>
				<?php endif; ?>
			<?php endif; ?>
		<?php endif; ?>
	</ul>
</div>
<?php } ?>
<div class="cmloc-location-index-map cmloc-theme-style" data-map-style='<?php echo $mapStyle ?? '[]'; ?>' style="<?php
		if (!empty($atts['mapwidth'])) echo 'width:' . $atts['mapwidth'] .'px;';
		if (!empty($atts['mapheight'])) echo 'height:' . $atts['mapheight'] .'px;';
		if ($index_map_enable == 0) echo 'display:none';
	?>">
	<div id="cmloc-location-index-map-canvas" style="<?php
		if (!empty($atts['mapwidth'])) echo 'width:' . $atts['mapwidth'] .'px;';
		if (!empty($atts['mapheight'])) echo 'height:' . $atts['mapheight'] .'px;';
	?>"></div>
	<?php
	if (defined('DOING_AJAX') && DOING_AJAX) {
		$printScript();
	} else {
		add_action('wp_footer', $printScript, PHP_INT_MAX);
	}
	?>
</div>