<?php
namespace com\cminds\maplocations\controller;

use com\cminds\maplocations\model\Category;
use com\cminds\maplocations\model\Labels;
use com\cminds\maplocations\model\Settings;
use com\cminds\maplocations\helper\RouteView;
use com\cminds\maplocations\shortcode\LocationSnippetShortcode;
?>
<div class="cmloc-locations-archive cmloc-layout-<?php echo $layout;
	?>"<?php echo RouteView::getDisplayParams($displayParams); ?>>
	<?php get_template_part('cmloc', 'route-index-filter'); ?>
	<?php get_template_part('cmloc', 'route-index-map'); ?>
	<?php get_template_part('cmloc', 'route-index-list'); ?>
</div>
<?php
$currentCategoryId = 0;
$currentCategorySlug = FrontendController::$query->get(Category::TAXONOMY);
if ($term = get_term_by('slug', $currentCategorySlug, Category::TAXONOMY)) {
	$currentCategoryId = $term->term_id;
}
if($currentCategoryId > 0) {
	$link_share_enable = Settings::getOption(Settings::OPTION_LINK_SHARE_ENABLE);
	$link_share_page_id = Settings::getOption(Settings::OPTION_LINK_SHARE_PAGE_ID);
	$location_category_link_url = '';
	if($link_share_page_id) {
		$location_category_link_url = get_the_permalink($link_share_page_id).'?category='.$currentCategorySlug;
	}
	?>
	<?php if($link_share_enable == '1') { ?>
	<div class="location_share_link_box">
		<h6><?php echo Labels::getLocalized('location_link_sharing'); ?></h6>
		<div class="location_share_link_row location_category_share_link">
			<input type="text" value="<?php echo $location_category_link_url; ?>" id="cmloc_location_ccategory_input" readonly="readonly" />
			<button onclick="cmloc_location_ccategory_link()" id="cmloc_location_ccategory_button"><?php echo Labels::getLocalized('location_copy_location_category'); ?></button>
		</div>
	</div>
	<script type="text/javascript">
	function cmloc_location_ccategory_link() {
		var copyText = document.getElementById("cmloc_location_ccategory_input");
		copyText.select();
		copyText.setSelectionRange(0, 99999);
		document.execCommand("copy");
		document.getElementById("cmloc_location_ccategory_button").innerHTML = '<?php echo Labels::getLocalized("location_copied"); ?>';
		setTimeout(function(){ document.getElementById("cmloc_location_ccategory_button").innerHTML = '<?php echo Labels::getLocalized("location_copy_location_category"); ?>'; }, 3000);
	} 
	</script>
	<?php
	}
}
?>