<?php
use com\cminds\maplocations\model\Settings;
use com\cminds\maplocations\model\Labels;

$link_share_enable = Settings::getOption(Settings::OPTION_LINK_SHARE_ENABLE);
$link_share_page_id = Settings::getOption(Settings::OPTION_LINK_SHARE_PAGE_ID);

global $post;

$location_link_url = '';
$location_category_link_url = '';
if($link_share_page_id) {

	$location_link_url = get_the_permalink($link_share_page_id).'?location='.$post->post_name;

	$categories_id = '';
	$categories = $route->getCategories();
	if(count($categories) > 0) {
		foreach ($categories as $item) {
			$categories_id .= ','.$item->getSlug();
		}
		$categories_id = substr($categories_id, 1);
	}
	if($categories_id) {
		$location_category_link_url = get_the_permalink($link_share_page_id).'?category='.$categories_id;
	} else {
		$location_category_link_url = get_the_permalink($link_share_page_id);
	}
}

// if (empty($atts['mapheight'])) $atts['mapheight'] = 600;
?>
<div class="cmloc-location-map-canvas-outer" style="display:<?php echo (!isset($atts['map']) OR $atts['map'] == 1) ? 'block' : 'none'; ?>">
	<div id="<?php echo $mapId; ?>" class="cmloc-location-map-canvas" style="<?php
		if (!empty($atts['mapwidth'])) echo 'width:' . $atts['mapwidth'] .'px;';
		if (!empty($atts['mapheight'])) echo 'height:' . $atts['mapheight'] .'px;';
	?>"></div>
</div>
<?php // add_action('wp_footer', function() use ($mapId, $route) { ?>
<script type="text/javascript">
jQuery(function($) {
	var mapId = <?php echo json_encode($mapId); ?>;
	var locations = <?php echo json_encode($route->getJSLocations()); ?>;
	var pathColor = null;
	document.getElementById(mapId).cmloc_route = new CMLOC_Route(mapId, locations, pathColor);
});
</script>
<?php // }); ?>
<?php if($link_share_enable == '1') { ?>
<div class="location_share_link_box">
	<h6><?php echo Labels::getLocalized('location_link_sharing'); ?></h6>
	<div class="location_share_link_row location_share_link">
		<input type="text" value="<?php echo $location_link_url; ?>" id="cmloc_location_input" readonly="readonly" />
		<button onclick="cmloc_location_link()" id="cmloc_location_button"><?php echo Labels::getLocalized('location_copy_location'); ?></button>
	</div>
	<div class="location_share_link_row location_category_share_link">
		<input type="text" value="<?php echo $location_category_link_url; ?>" id="cmloc_location_category_input" readonly="readonly" />
		<button onclick="cmloc_location_category_link()" id="cmloc_location_category_button"><?php echo Labels::getLocalized('location_copy_location_category'); ?></button>
	</div>
</div>
<script type="text/javascript">
function cmloc_location_link() {
	var copyText = document.getElementById("cmloc_location_input");
	copyText.select();
	copyText.setSelectionRange(0, 99999);
	document.execCommand("copy");
	document.getElementById("cmloc_location_button").innerHTML = '<?php echo Labels::getLocalized("location_copied"); ?>';
	setTimeout(function(){ document.getElementById("cmloc_location_button").innerHTML = '<?php echo Labels::getLocalized("location_copy_location"); ?>'; }, 3000);
} 
function cmloc_location_category_link() {
	var copyText = document.getElementById("cmloc_location_category_input");
	copyText.select();
	copyText.setSelectionRange(0, 99999);
	document.execCommand("copy");
	document.getElementById("cmloc_location_category_button").innerHTML = '<?php echo Labels::getLocalized("location_copied"); ?>';
	setTimeout(function(){ document.getElementById("cmloc_location_category_button").innerHTML = '<?php echo Labels::getLocalized("location_copy_location_category"); ?>'; }, 3000);
} 
</script>
<?php } ?>