<?php
use com\cminds\maplocations\shortcode\LocationSnippetShortcode;
use com\cminds\maplocations\model\Labels;
use com\cminds\maplocations\model\Settings;
use com\cminds\maplocations\helper\RouteView;
use com\cminds\maplocations\controller\RouteController;
use com\cminds\maplocations\model\Route;
use com\cminds\maplocations\model\Attachment;
/* @var $route Route */
$location = $route->getLocation();
if(Settings::getOption(Settings::OPTION_INDEX_LIST_ITEM_CLICK) == 'custom_redirect') {
	$link_url = ($location->getUrl()!='')?$location->getUrl():'#';
} else if(Settings::getOption(Settings::OPTION_INDEX_LIST_ITEM_CLICK) == 'redirect') {
	$link_url = $route->getPermalink();
} else {
	$link_url = "javascript:void(0);";
}
?><div class="cmloc-location-snippet" data-route-id="<?php echo $route->getId(); ?>">
	<?php if (LocationSnippetShortcode::FEATURED_NONE != $atts['featured']): ?>
		<div class="cmloc-location-featured-image"><?php echo RouteView::getFeaturedImage($route, $atts); ?></div>
	<?php endif; ?>
	<div class="cmloc-created-date"><?php echo get_the_date(get_option('date_format'), $route->getId()); ?></div>
	<h2><a href="<?php echo esc_attr($link_url); ?>" class="cmloc-location-link"><?php echo esc_html($route->getTitle()); ?></a></h2>
	<div class="cmloc-address">
		<span><?php echo $route->getAddress(); ?></span>
	</div>
	<div class="cmloc-postal-code">
		<span><?php echo esc_html($route->getPostalCode()); ?></span>
	</div>
	<?php do_action('cmloc_route_snippet_middle', $route); ?>
	<?php if ($categories = $route->getCategories()) RouteView::displayTermsInlineNav(Labels::getLocalized('categories'), 'categories', $categories); ?>
	<?php do_action('cmloc_route_snippet_bottom', $route); ?>
	<div class="clear"></div>
</div>